
#include <p33EP512GM710.h>
#include <math.h>
#include <stdio.h>
#include<stdbool.h>

_FOSCSEL( FNOSC_PRI );                              // Select Primary Oscillator (Posc) at POR (Power-on Reset)
_FOSC( POSCMD_XT & OSCIOFNC_OFF & FCKSM_CSECMD );   // Configure Posc in HS mode, Enable clock switching
_FWDT( WDTPOST_PS32768 & FWDTEN_OFF );
_FICD( JTAGEN_OFF );

//--- prototype de fonction ---//

void Init_Osci(void);
void Init_Timer2(void);
void Init_PWM(void);
void Init_Port(void);
double m1,m2,m3;                   // m sinus modulante
float M=0;                        // Amplitude modulante
double f=0;                          // Frquence de la modulante
double a=0;                       // Calcul pour 2*pi*f
double t=0;
float b=0;
float dephasage=0;                // Dphasage du sinus
long FMLI=0;                      // Frquence MLI
long c=0;                         // Variable pour le calcul de PDC c= Fosc/Fmli
bool flagpwm=0;
int main(void)
{

    RCONbits.SWDTEN=0;           // Disable Watch Dog Timer

    Init_Port();
    Init_Osci();                // Oscilator initialisation
    Init_Timer2();              // Timer2 initialisation
    Init_PWM();                 // PWM initialisation
    M=0.6;
    f=400.0;
    FMLI=10000;
    b=0.5*M;
    a=2.0*3.141592*f;
    c=140000000/FMLI;
    dephasage=(2*3.141592)/3;
    PTCONbits.PTEN = 1;

	while(1)
        {

            if(flagpwm=1)
            {
              
                if(t>25)
                  {
                        t=0;
                  }
               // m1 = 0.5+(b*sin(a*t));
                m1 = sin(a*t);
                if (m1>0)
                {
                 _LATG2 = 1;
                }
                else
                {
                _LATG2 = 0;
                }
                 t=t+0.0001;
                //PDC1 = c*m1;
                //m2 = 0.5+(b*sin((a*t)-(dephasage)));
                //PDC2 = c*m2;
                //m3 = 0.5+(b*sin((a*t)+(dephasage)));
                //PDC4 = c*m3;
                flagpwm=0;
            }


           /* if (PORTCbits.RC6==1)
            {
                LATFbits.LATF7 = 1;
                PTCONbits.PTEN = 0;         // disable PWM Module
            }
            if (PORTCbits.RC7==1)
            {
                LATFbits.LATF7 = 1;
                PTCONbits.PTEN = 0;         // disable PWM Module
            }
            if (PORTCbits.RC9==1)
            {
                LATFbits.LATF7 = 1;
                PTCONbits.PTEN = 0;         // disable PWM Module
            }*/

        }
}

/*---------------------------------------------------------------------
  Function Name: Init_Osci
  Description:   Initialize oscillator
  Inputs:        None
  Returns:       None
-----------------------------------------------------------------------*/
void Init_Osci( void )    // Fonction pour initialiser l'oscillateur

{
    // Configure Oscillator to operate the device at 40Mhz
    // Fosc= Fin*M/(N1*N2), Fcy=Fosc/2
    // Fosc= 40M*49/(2*7)=140Mhz for 40M input clock

    // Configure PLL prescaler, PLL postscaler, PLL divisor
    CLKDIV = 0x05; 			// N2 = 7 N1=2
    PLLFBD = 0xF3;			// M = 245

    //  Clock switching to incorporate PLL (NOSC=0b011)
    __builtin_write_OSCCONH(0x03); 		// Initiate Clock Switch to Primary Oscillator with PLL (NOSC=0b011)										// configuration du registre NOSC (OSCCON) -->
    __builtin_write_OSCCONL(0x01);		// Start clock switching

    // Wait for Clock switch to occur
    while(OSCCONbits.COSC != 0b011);

    // Wait for PLL to lock
    while(OSCCONbits.LOCK != 1);
}


/*---------------------------------------------------------------------
  Function Name: Init_Port
  Description:   Initialize I/O
  Inputs:        None
  Returns:       None
-----------------------------------------------------------------------*/
void Init_Port( void )      // Fonction pour initialiser les I/O

{
    TRISG = 0x0000;         // Port B is an output
    ANSELG = 0;        // Enables digital port pin

    TRISF = 0x0000;         // Port F is an output
    ANSELF = 0;        // Enables digital port pin

    TRISA = 0x0000;         // Port A is an output
    ANSELA = 0;        // Enables digital port pin
    //ODCAbits.ODCA10=1;
    //ODCAbits.ODCA7=1;

    TRISB = 0x0000;         // Port B is an output
    ANSELB = 0;        // Enables digital port pin
    
   //ODCBbits.ODCB14=1;
   //ODCBbits.ODCB15=1;
   //ODCBbits.ODCB13=1;
   //ODCBbits.ODCB12=1;
    



    TRISD = 0x0000;         // Port D is an output
    ANSELD = 0;        // Enables digital port pin

    TRISC = 1;         // Port C is an input
    ANSELC = 0;        // Enables digital port pin
    PORTC = 0;
}


/*---------------------------------------------------------------------
  Function Name: Init_Timer2
  Description:   Initialize Timer2 10kHz ---> 100us
  Inputs:        None
  Returns:       None
-----------------------------------------------------------------------*/
void Init_Timer2( void )    // Initialize Timer2

{
    T2CONbits.TON = 0;      // Disable Timer
    T2CONbits.T32 = 0;      // Timer 16 bits
    T2CONbits.TCS = 0;      // Select internal instruction cycle clock (Fosc/2)
    T2CONbits.TGATE = 0;    // Disable Gated Timer mode
    T2CONbits.TCKPS = 0;    // Select 1:1 Prescaler (70MHz--->14285ps)


    IFS0bits.T2IF = 0;      // Reset Timer2 interrupt flag
    IPC1bits.T2IP = 2;      // Timer1 Interrupt priority level=4
    IEC0bits.T2IE = 1;      // Enable Timer2 interrupt

    TMR2= 0;                // Clear timer register
    PR2 = 6960;             // Load the period value (100us/14285ps=7000)   6960 pour l'ajustement

    T2CONbits.TON = 1;      // Enable Timer2 and start the counter
}

/*---------------------------------------------------------------------
  Function Name: Init_PWM
  Description:   Initialize PWM
  Inputs:        None
  Returns:       None
-----------------------------------------------------------------------*/
void Init_PWM(void)             // Initialize PWM

{
    PTCON2bits.PCLKDIV = 0;     // 1:1 PWM prescaler
    PWMCON1bits.ITB = 0;        // PTPER provides the PWM time period value
    PWMCON2bits.ITB = 0;
    PWMCON4bits.ITB = 0;

    PTPER = 14000;               // Set PWM Period on Primary Time Base PTPER=Fosc/(Fpwm*PWMprescaler)=140MHz/(10kHz*1)

    PWMCON1bits.MDCS = 0;       // PDCx provides duty cycle value
    PWMCON2bits.MDCS = 0;
    PWMCON4bits.MDCS = 0;

    PDC1 = 7000;                // Independent Primary Duty Cycle is 50% of the period PDCx=(Fosc/(Fpwm*PWMprescaler))*DesiredDuty Cycle=(140MHz/(10kHz*1))*0.5=7000
    PDC2 = 7000;
    PDC4 = 7000;

    PHASE1 = 0;                 // Primary phase shift value  PTPER*value phase/360
    PHASE2 = 0;          // 333.333
    PHASE4 = 0;          // 666.666

    DTR1 = 0;                   // Set Dead Time Values  Fosc*(Desired dead time/PWMprescaler)= 80MHz*(1us/2)
    ALTDTR1 = 0;
    DTR2 = 0;                   // Set Dead Time Values  Fosc*(Desired dead time/PWMprescaler)
    ALTDTR2 = 0;
    DTR4 = 0;                   // Set Dead Time Values  Fosc*(Desired dead time/PWMprescaler)
    ALTDTR4 = 0;

    IOCON1bits.PENH = 1;        // PWM module controls PWM1H pin
    IOCON1bits.PENL = 1;        // PWM module controls PWM1L pin
    IOCON1bits.PMOD = 0;        // Set PWM Mode to Complementary
    IOCON2bits.PENH = 1;        // PWM module controls PWM1H pin
    IOCON2bits.PENL = 1;        // PWM module controls PWM1L pin
    IOCON2bits.PMOD = 0;        // Set PWM Mode to Complementary
    IOCON4bits.PENH = 1;        // PWM module controls PWM1H pin
    IOCON4bits.PENL = 1;        // PWM module controls PWM1L pin
    IOCON4bits.PMOD = 0;        // Set PWM Mode to Complementary

    PWMCON1 = 0x0000;           // Set Primary Time Base, Edge-Aligned Mode and Independent Duty Cycles
    PWMCON2 = 0x0000;
    PWMCON4 = 0x0000;
    FCLCON1 = 0x0003;           // Configure Faults
    FCLCON2 = 0x0003;
    FCLCON4 = 0x0003;
    _PWM1IP=6;

    PWMCON1bits.IUE = 0;        // PDCx immediate update
    PWMCON2bits.IUE = 0;
    PWMCON4bits.IUE = 0;
    

    PTCONbits.PTEN = 1;         // Enable PWM Module
    LATGbits.LATG10 = 1;
   // LATGbits.LATG3 = 1;
}

/*---------------------------------------------------------------------
  Function Name: _T2Interrupt
  Description:   interruption li au timer, doit faire clignoter une led
                 chaque fois qu'on arrive dans cette boucle
  Inputs:        None
  Returns:       None
-----------------------------------------------------------------------*/
 void __attribute__((interrupt,no_auto_psv)) _T2Interrupt( void )
 {
    IFS0bits.T2IF = 0; 		// remise  zro du flag d'interruption

    // prend l'tat inverse de l'tat prcdent
   LATGbits.LATG11 = ~LATGbits.LATG11;


   flagpwm=1;
    
  
   TMR2 = 0;
   T2CONbits.TON = 1;		// activer  nouveau le Timer

 }
